﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.Organization
@{ ViewData["Title"] = "Index";}

<style>
    span.icon img {
        width: 18px;
        height: 16px;
        margin-top: 9px;
        cursor: pointer;
    }
    .backtolist {
        margin-top: 5px !important;
    }
</style>

<script src="~/Script/Master/Layout.js"></script>
<script src="~/Script/ApplicationManagement/OrgAssignToConsultant.js"></script>
<script>
    $(document).ready(function () {

        debugger
        if ($("#Id").val() > 0) {
            $(".titile_heading h1").html("Assign Organization");
            $(".service_line").addClass("active");
            $('#DdlRole').val([@Model.ConsultantIds]).change();
            $(".assign_panel").hide();
            $(".titile_heading").show();
            $('.multiple').multiselect('rebuild');
        } else {
            $(".titile_heading h1").html("Assigned Organizations");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
    });
    function fn_openPopup() {
        $.ajax({
            url: "/ApplicationManagement/OrganzationAssignToConsultant/GetOrganizationNotAssigned",
            type: "POST",
            data: {  },
            success: function (res) {
                if (res.length > 0) {
                    $('#OrgID').find('option:not(:first)').remove();
                    for (var i = 0; i < res.length; i++) {
                        $("#OrgID").append("<option value=" + res[i].id + ">" + res[i].orgName + "</option>");
                    }
                }
                else {
                    $('#OrgID').find('option:not(:first)').remove();
                }
                $("#OrgID").prop("disabled", false);
                $('#OrgID').val('');
                $('#RoleId').val('');
                $("#RoleId").multiselect('rebuild');
                $("#AssignOrgToAdminClient").modal('show');
                $(".modal-backdrop").addClass('in');
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }
    function fn_saveAssignedClient() {
        if ($('#OrgID').val() == "") {
            toastr.error('Please select an organization! ')
            return false;
        }
        if ($('#RoleId').val() == "" || $('#RoleId').val() == null) {
            toastr.error('Please select Employee! ')
            return false;
        }
        else {
            var QuestionnaireXML = [], Sn = 0;
            var str = $("#RoleId").val().toString().replace("multiselect-all,", "");
            var array = str.split(",");
            $.each(array, function (i) {
                QuestionnaireXML[Sn++] = {
                    OrgId: $("#OrgID").val(),
                    EmpIds: array[i]
                }
            });
            //alert(JSON.stringify(QuestionnaireXML));
            var model ={
                OrgID: $("#OrgID").val(),
                OrganizationXML: JSON.stringify(QuestionnaireXML)
            }
        }
        $.ajax({
            url: "/ApplicationManagement/OrganzationAssignToConsultant/SaveAssignedOrganizationUser",
            type: "POST",
            data: { model: model },
            success: function (res) {
                if (res.isSuccess) {
                    toastr.success($("#OrgID option:selected").text() + ' Organiztion Assigned Successfully.')
                    $(".modal-backdrop").remove();
                    $('#AssignOrgToAdminClient').modal('hide');
                    $.get('/ApplicationManagement/OrganzationAssignToConsultant/Index', { }, (res) => $('#ajaxresult').html(res))
                } else {
                    toastr.error('Somthing went wrong!');
                }
            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })

    }
    function fn_EditAssignedOrg(input) {
        $.ajax({
            url: "/ApplicationManagement/OrganzationAssignToConsultant/EditAssignedOrg",
            type: "POST",
            data: { OrgID: input },
            success: function (result) {
                debugger
                if (result.res2.length > 0) {
                    $('#OrgID').find('option:not(:first)').remove();
                    for (var i = 0; i < result.res2.length; i++) {
                        $("#OrgID").append("<option value=" + result.res2[i].id + ">" + result.res2[i].parentOrgName + "</option>");
                    }
                }
                else {
                    $('#OrgID').find('option:not(:first)').remove();
                }
                $('#OrgID').val(result.res[0].id);
                $("#OrgID").prop("disabled", true);
                $('#RoleId').val(result.res[0].employeeName.split(",")).change();
                $("#RoleId").multiselect('rebuild');
                $('#AssignOrgToAdminClient').modal('show');
                $(".modal-backdrop").addClass('in');

            },
            error: function (ex) {
                console.log(ex.responseText);
            }
        })
    }
</script>


<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Assign Organization</h1>
            @*<a class="btn btn-danger pull-right" href="/ApplicationManagement/Organogram/TabMenu" style=" margin-top: 4px;">Back to Menu</a>*@            <a class="backtolist" href="/ApplicationManagement/Organogram/TabMenu">Back to Menu</a>            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
<script>toastr.success('@ViewBag.message')</script>}
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        @Html.HiddenFor(m => m.Id)
                        @Html.HiddenFor(m => m.ConsultantIds)
                        <div class="pb-2 mt-4 mb-2 border-bottom box_title">Assign Consultant</div>
                        <div class="row">
                            <div class="col-md-4 col-sm-6 col-xs-12">
                                <label class="required">Name(Parent Organization)</label>
                                <div class="select_box m_bottom">
                                    <input type="text" class="form-control m_no" readonly="readonly" required name="ParentOrgName" id="ParentOrgName" value="@Model.ParentOrgName" placeholder="Enter parent org. name">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-4 col-sm-6 col-xs-12">
                                <label>Consultant</label>
                                <div class="select_box m_bottom">
                                    @Html.DropDownList("DdlRole", Model.DdlRole, new { @class = "form-control m_no multiple chosen-select", multiple = "multiple" })
                                </div>
                            </div>
                        </div>
                        <div class="row pt-3">
                            <div class="col-md-12 col-sm-12 col-xs-12">
                                <div class="back_btn">
                                    <div class="back_btn_in">
                                        <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                    </div>
                                </div>
                                <div class="submitbtn">
                                    <input type="button" value="Submit" onclick="submitForm()">
                                    <script>
                                        function submitForm() {
                                            var consultantIds = [];
                                            $('#DdlRole option:selected').each(function (i, option) {
                                                if ($(option).val() == 'multiselect-all') {
                                                    return;
                                                }
                                                consultantIds.push($(option).val());
                                            })
                                            $('#ConsultantIds').val(consultantIds.toString());
                                            $('#form').submit();
                                        }
                                    </script>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="addbtn pb-3">
                                        <div class="add_litigation">
                                            <span>+</span>
                                            <input type="button" name="assign organization" onclick="fn_openPopup()" value="Assign Organization">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">S.No.</th>
                                                <th>Organization Name</th>
                                                <th>Assigned To</th>
                                                @*<th>Assigned Date</th>*@
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.OrganizationList)
                                            {
                                <tr>                                    <td>@(++sn)</td>                                    <td>@item.OrgName</td>                                    <td>@item.EmployeeName</td>                                    @*<td>@item.AssignDate</td>*@                                    @*<td><a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-Id="@item.Id" asp-controller="OrganzationAssignToConsultant" asp-area="ApplicationManagement" class="edit_btn"></a></td>*@                                    <td><a class="edit_btn" onclick="fn_EditAssignedOrg(@item.Id)"></a></td>                                </tr>}                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div class="modal fade" id="AssignOrgToAdminClient" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-lg " role="document">
        <div class="modal-content">
            <div class="pb-2 mt-4 mb-2 border-bottom box_title pl-4">
                ASSIGN ORGANIZATION
            </div>            <div class="modal-body">
                <div class="row" style=" margin-bottom: 10px;">
                    <div class="col-md-2 col-sm-6 col-xs-12">
                        @Html.Label("Organization")
                    </div>
                    <div class="col-md-4 col-sm-6 col-xs-12">
                        @Html.DropDownListFor(m => m.OrgID, Enumerable.Empty<SelectListItem>(), "Select Organization", new { @class = "form-control m_no chosen-select", required = "required", placeholder = "Select an option" })
                    </div>
                    <div class="col-md-2 col-sm-6 col-xs-12">
                        @Html.Label("Select Employee")
                    </div>
                    <div class="col-md-4 col-sm-6 col-xs-12">
                        @Html.DropDownListFor(m => m.RoleId, Model.DdlRole, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
                    </div>
                </div>
                <div class="modal-footer">
                    <a class="btn btn-danger" data-dismiss="modal" href="#AssignOrgToAdminClient">Close</a>
                    <button type="button" class="btn btn-primary" onclick="fn_saveAssignedClient()">Save</button>
                </div>
            </div>
        </div>
    </div>
</div>